/* $Id: ball.hpp,v 1.5 2005/10/20 19:46:52 chfreund Exp $ */

#ifndef _BALL_HPP_
#define _BALL_HPP_

/**********************************************************/

#include "global.hpp"
#include "constants.hpp"
#include "collidableobject.hpp"
#include "audio.hpp"
#include "vector.hpp"
#include "counter.hpp"

/**********************************************************/

class Ball : public CollidableObject {
	public:
		Ball();
		~Ball();
		bool initialize( const Vector& pos, const Vector& vel,
		                 const real initialScoringDelay );
		virtual Sint32 getID() const { return BALL; }
		virtual void update();
		virtual int applyDamage( const Particles::ParticleData& p );

		virtual void serialize( Uint8*& bufferPointer ) const;
		virtual void deserialize( Uint8*& bufferPointer );
		virtual Uint32 getSerializeBufferSize() const;

	protected:
		static Mix_Chunk* m_explodeSample, * m_bounceSample, * m_damageSample;
		real m_initialScoringDelay;
		Counter m_scoringDelay;
};

/**********************************************************/

#endif /* _BALL_HPP_ */
