/* $Id: noncollidableobject.cpp,v 1.6 2005/10/19 05:34:32 pohlt Exp $ */

#include "noncollidableobject.hpp"

/******************************************************************************/

void NonCollidableObject::serialize( Uint8*& bufferPointer ) const {
	// expands to a check of the buffer movement
	START_OBJECT_SERIALIZED_SIZE_CHECK( bufferPointer );

	AttachableObject::serialize( bufferPointer );	

	Serialize<bool>::serialize( m_drawBeforeCollidableObjects, bufferPointer );

	// expands to tag serialization
	SERIALIZE_OBJECT_TAG( bufferPointer );
	// expands to a check of the buffer movement
	END_OBJECT_SERIALIZED_SIZE_CHECK( bufferPointer, NonCollidableObject );
}

/******************************************************************************/

void NonCollidableObject::deserialize( Uint8*& bufferPointer ) {
	AttachableObject::deserialize( bufferPointer );

	Serialize<bool>::deserialize( bufferPointer, m_drawBeforeCollidableObjects );

	// expands to tag deserialization
	DESERIALIZE_OBJECT_TAG( bufferPointer );
}

/******************************************************************************/

Uint32 NonCollidableObject::getSerializeBufferSize() const {
	return AttachableObject::getSerializeBufferSize() +
	       Serialize<bool>::sizeOf( m_drawBeforeCollidableObjects )

	       // adds additional size for debugging (see serialize.hpp),
	       // but only, if the tags are used
	       PLUS_TAG_SIZE( 1 );
}

/******************************************************************************/
