/* $Id: weaponmissile.cpp,v 1.13 2005/12/21 10:22:17 pohlt Exp $ */

#include "weaponmissile.hpp"
#include "world.hpp"
#include "avatar.hpp"
#include "stationarygun.hpp"

bool WeaponMissile::reallyShoot( World* world, Avatar* avatar,
                                 const StationaryGun* gun ) const {
	// place missile
	Missile* const missile = dynamic_cast<Missile*>( world->newObject( MISSILE ));
	if( gun )
		return missile->initialize(
		       gun->getShootingPoint(),
		       gun->getRandomizedAimingVector( 2 )*0.25,
		       avatar->getPlayer()->getPlayerID(), 300, 13, 15,
		       gun->getRandomizedAimingVector( 2 )*130 );
	else
		return missile->initialize(
		       avatar->placeBesideCollRect( missile->getCollRectX() + missile->getCollRectWidth() - 1,
		                                    -missile->getCollRectX(),
		                                    missile->getCollRectY() + missile->getCollRectHeight() - 1,
		                                    -missile->getCollRectY() ),
		       avatar->getRandomizedAimingVector( 2 )*0.25 + avatar->getVel(),
		       avatar->getPlayer()->getPlayerID(), 300, 13, 15,
		       avatar->getRandomizedAimingVector( 2 )*130 );
}
