/* $Id: goal.hpp,v 1.5 2005/10/16 17:53:05 pohlt Exp $ */

#ifndef _GOAL_HPP_
#define _GOAL_HPP_

/**********************************************************/

#include "constants.hpp"
#include "noncollidableobject.hpp"
#include "vector.hpp"

/**********************************************************/

//! class for goal
class Goal : public NonCollidableObject {
	public:

		Goal( void );
		~Goal( void );
		bool initialize( const Vector& pos, const Vector& vel);

		//! implementation of the pure virtual function inherited from
		//! class Object, returns the constant defined in constants.hpp
		virtual Sint32 getID( void ) const { return GOAL_50; }

		virtual void update( void );
		bool testInside( const Vector& pos );

		virtual Uint32 getSerializeBufferSize() const;
		virtual void serialize( Uint8*& bufferPointer ) const;
		virtual void deserialize( Uint8*& bufferPointer );

	protected:
		static const int m_size = 50;
		static const Sint32 m_initialNewDirDelay = 3000;
		Sint32 m_newDirDelay;
};

/**********************************************************/

#endif // _GOAL_HPP_
