#ifndef _MESSAGEWIDGET_HPP_
#define _MESSAGEWIDGET_HPP_

#include <string>
#include <vector>
#include <SDL.h>
#include <SDL_ttf.h>
#include "widget.h"
using namespace SDLwidgets;

class MessageWidget : public WidgetLeaf {
private:
	TTF_Font* m_font;
	std::vector<std::string> m_messageLine;
	std::vector<SDL_Color> m_messageColor;
public:
	MessageWidget( int width, int height );
	virtual ~MessageWidget();
	void setFont( std::string fontName, int fontSize );
	virtual void draw( SDL_Surface* surface );
	void addMessage( std::string message, const SDL_Color& color ) {
		m_messageLine.push_back( message );
		m_messageColor.push_back( color );
	}
};

#endif // _MESSAGEWIDGET_HPP_
