/* $Id: version.hpp,v 1.1 2005/12/18 19:19:33 chfreund Exp $ */

#ifndef _VERSION_HPP_
#define _VERSION_HPP_

#include "serializable.hpp"
#include "serialize.hpp"
#include <string>

#define WOP_MAJOR_VERSION 0
#define WOP_MINOR_VERSION 4
#define WOP_PATCHLEVEL    0

//! This version information struct is heavily inspired by the
//! SDL library

struct Version : public Serializable {
	Uint8 major;
	Uint8 minor;
	Uint8 patch;
	
	Version( Uint8 mjr, Uint8 mnr, Uint8 pch ) {
		major = mjr;
		minor = mnr;
		patch = pch;
	}
	
	std::string getString() const;
	
	Uint32 getSerializeBufferSize() const {
		return 3 * Serialize<Uint8>::sizeOf();
	}
	void serialize( Uint8*& bufferPointer ) const;
	void deserialize( Uint8*& bufferPointer );
};

Version getWopVersion();

#endif // _VERSION_HPP_
