/* $Id: weapongrenade.cpp,v 1.22 2005/12/21 11:33:13 pohlt Exp $ */

#include "weapongrenade.hpp"
#include "world.hpp"
#include "avatar.hpp"
#include "stationarygun.hpp"

bool WeaponGrenade::reallyShoot( World* world, Avatar* avatar,
                                 const StationaryGun* gun ) const {
	// initialize grenade
	const real power = 7 + 2 * world->getRandom().getNormedReal();
	Uint32 type = m_type;

	// dud? remove any triggering
	if( world->getRandom().getUint32Between( 0, 10 ) == 0) {
		type &= ~(Grenade::TIME_TRIGGERED | Grenade::CONTACT_TRIGGERED);
	}

	const Uint32 ttl = world->getRandom().getUint32Between( 60, 75 );
	Grenade* const grenade = dynamic_cast<Grenade*>( world->newObject( GRENADE ));
	
	if( gun )
		return grenade->initialize(
		       gun->getShootingPoint(),
		       gun->getRandomizedAimingVector( 2 )*power*2.0,
		       avatar->getPlayer()->getPlayerID(), type, ROUND( 0.25*ttl ), 250, 18 );
	else
		return grenade->initialize(
		       avatar->placeBesideCollRect( grenade->getCollRectX() + grenade->getCollRectWidth() - 1,
		                                    -grenade->getCollRectX(),
		                                    grenade->getCollRectY() + grenade->getCollRectHeight() - 1,
		                                    -grenade->getCollRectY() ),
		       avatar->getRandomizedAimingVector( 2 )*power + avatar->getVel(),
		       avatar->getPlayer()->getPlayerID(), type, ttl, 250, 18 );
}
