/* $Id: weaponuzi.cpp,v 1.24 2005/10/21 08:02:53 pohlt Exp $ */

#include "weaponuzi.hpp"
#include "world.hpp"
#include "avatar.hpp"

bool WeaponUzi::reallyShoot( World* world, Avatar* avatar,
                             const StationaryGun* gun ) const {
	// place bullet particle
	const real power = 30.0 - 6.0 * world->getRandom().getNormedReal();
	world->getParticles()->addParticle( Particles::ParticleData(
			avatar->placeBesideCollRect(),
			avatar->getRandomizedAimingVector( 2 )*power + avatar->getVel(),
			Particles::EXPL_EARTH | Particles::EXPL_OBJECT | Particles::DAMAGE | Particles::EXPL_GEN_SPARKS,
			0, avatar->getPlayer()->getPlayerID(), 100, 40, 0xffffff));

	// place bullet casing
	world->getParticles()->addParticle( Particles::ParticleData(
			Vector( avatar->getPosX() +
			        (avatar->isFacingRight() ? 5 : -5),
			        avatar->getPosY() + avatar->getWeaponPivotDY() ),
			Vector(  0.5*(0.5 - world->getRandom().getNormedReal() ),
			        -0.7*(1.0 + world->getRandom().getNormedReal() ) ) + avatar->getVel(),
			Particles::BOUNCE_EARTH | Particles::REDUNDANT, 0, 0, 75, 1, 0xaaaaaa ) );

	// apply recoil
	avatar->addForce( -avatar->getAimingVector() * power / world->getDT( avatar->getPos() ));

	return true;
}
